{
  "x-generator": "On Key REST API Docs Generator",
  "openapi": "3.0.0",
  "info": {
    "title": "On Key FIN  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "servers": [
    {
      "url": "{scheme}://{server}:{port}/api/tenants/{client}/{connection}",
      "description": "On Key API Server",
      "variables": {
        "scheme": {
          "default": "https",
          "description": "HTTP scheme"
        },
        "server": {
          "default": "<variable>",
          "description": "Server host"
        },
        "port": {
          "default": "443",
          "description": "Port"
        },
        "client": {
          "default": "<variable>",
          "description": "Client"
        },
        "connection": {
          "default": "<variable>",
          "description": "Connection/Environment (i.e. prod, qa)"
        }
      }
    }
  ],
  "paths": {
    "/Modules/FIN/Budgets/{id}": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Get a Budget resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| createdByUserId | Budget->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Budget->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Budget->CreatedByUser_FullName | string |  |\r\n| createdOn | Budget->CreatedOn | string | date-time |\r\n| modifiedByUserId | Budget->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Budget->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Budget->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Budget->ModifiedOn | string | date-time |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Budget->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Budget->PermissionTree_Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| siteCode | Budget->Site_Code | string |  |\r\n| siteDescription | Budget->Site_Description | string |  |\r\n| id | Budget->Id | integer | int64 |\r\n| baseCurrencyId | Budget->BaseCurrency_Id | integer | int64 |\r\n| baseCurrencyCode | Budget->BaseCurrency_Code | string |  |\r\n| baseCurrencyDescription | Budget->BaseCurrency_Description | string |  |\r\n| budgetActualAmount | Budget->BudgetActualAmount | number | decimal |\r\n| budgetActualAmountInBaseCurrency | Budget->BudgetActualAmountInBaseCurrency | number | decimal |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetAmountInBaseCurrency | Budget->BudgetAmountInBaseCurrency | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| budgetTemplateCode | Budget->BudgetTemplate_Code | string |  |\r\n| budgetTemplateDescription | Budget->BudgetTemplate_Description | string |  |\r\n| budgetVarianceAmount | Budget->BudgetVarianceAmount | number | decimal |\r\n| budgetVarianceAmountInBaseCurrency | Budget->BudgetVarianceAmountInBaseCurrency | number | decimal |\r\n| conversionRate | Budget->ConversionRate | number | decimal |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| description | Budget->Description | string |  |\r\n| expression | Budget->Expression | string |  |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearId | Budget->FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | Budget->Notes | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n",
        "operationId": "GetBudget",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Budget",
            "content": {
              "application/vnd.onkey.entity+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetBudgetResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Update an existing Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n| expression | Budget->Expression | string |  |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| code | Budget->Code | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| expression | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n\r\n",
        "operationId": "UpdateBudget",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateBudgetResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Budget was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Budget"
        ],
        "summary": "Delete an existing Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteBudget",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "delete",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydelete+json": {
              "schema": {
                "$ref": "#/components/schemas/DeleteBudgetResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Budget was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Get a collection of Budget resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n| id | Budget->Id | integer | int64 |\r\n| code | Budget->Code | string |  |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetActualAmount | Budget->BudgetActualAmount | number | decimal |\r\n| budgetVarianceAmount | Budget->BudgetVarianceAmount | number | decimal |\r\n| budgetAmountInBaseCurrency | Budget->BudgetAmountInBaseCurrency | number | decimal |\r\n| budgetActualAmountInBaseCurrency | Budget->BudgetActualAmountInBaseCurrency | number | decimal |\r\n| budgetVarianceAmountInBaseCurrency | Budget->BudgetVarianceAmountInBaseCurrency | number | decimal |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| baseCurrencyCode | Budget->BaseCurrency_Code | string |  |\r\n| baseCurrencyDescription | Budget->BaseCurrency_Description | string |  |\r\n| createdOn | Budget->CreatedOn | string | date-time |\r\n| modifiedOn | Budget->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetBudgetCollection",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Budget collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetBudgetCollectionResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "post": {
        "tags": [
          "Budget"
        ],
        "summary": "Create a new Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| expression | Budget->Expression | string |  |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| financialYearPeriodId | Required | True |  |\r\n| financialYearPeriodId | Nullable | False |  |\r\n| expression | Required | True |  |\r\n| expression | Nullable | False |  |\r\n| currencyId | Required | True |  |\r\n| currencyId | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n| budgetAmount | Min Value | >= 0|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateBudget",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "post",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entity+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateBudgetResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "$ref": "#/components/responses/created",
            "description": ""
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetBudgetTemplate": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Budget Template for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetTemplate->Id | integer | int64 |\r\n| code | BudgetTemplate->Code | string |  |\r\n| description | BudgetTemplate->Description | string |  |\r\n| expression | BudgetTemplate->Expression | string |  |\r\n| budgetAmount | BudgetTemplate->BudgetAmount | number | decimal |\r\n",
        "operationId": "LookupBudgetBudgetTemplate",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Budget Template collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetBudgetTemplateLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetChangePermissionTree": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the permission set for changing the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetChangePermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetChangePermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetCurrency": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Currency for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Currency->Id | integer | int64 |\r\n| code | Currency->Code | string |  |\r\n| description | Currency->Description | string |  |\r\n",
        "operationId": "LookupBudgetCurrency",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Currency collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetCurrencyLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetFinancialYear": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Financial Year for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | FinancialYear->Id | integer | int64 |\r\n| code | FinancialYear->Code | string |  |\r\n| description | FinancialYear->Description | string |  |\r\n",
        "operationId": "LookupBudgetFinancialYear",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Financial Year collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetFinancialYearLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetFinancialYearPeriod": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Financial Year Period for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | FinancialYearPeriod->Id | integer | int64 |\r\n| code | FinancialYearPeriod->Code | string |  |\r\n| description | FinancialYearPeriod->Description | string |  |\r\n| financialYearId | FinancialYearPeriod->FinancialYear_Id | integer | int64 |\r\n| financialYearCode | FinancialYearPeriod->FinancialYear_Code | string |  |\r\n| financialYearDescription | FinancialYearPeriod->FinancialYear_Description | string |  |\r\n",
        "operationId": "LookupBudgetFinancialYearPeriod",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Financial Year Period collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetFinancialYearPeriodLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetInsertPermissionTree": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the permission set for creating the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetInsertPermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetInsertPermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Lookups/LookupBudgetSite": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Lookup the Site for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Site->Id | integer | int64 |\r\n| code | Site->Code | string |  |\r\n| description | Site->Description | string |  |\r\n| currencyId | Site->Currency_Id | integer | int64 |\r\n| currencyCode | Site->Currency_Code | string |  |\r\n| currencyDescription | Site->Currency_Description | string |  |\r\n",
        "operationId": "LookupBudgetSite",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Site collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetSiteLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Batch/{ids}": {
      "get": {
        "tags": [
          "Budget"
        ],
        "summary": "Get a collection of Budget resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| createdByUserId | Budget->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Budget->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Budget->CreatedByUser_FullName | string |  |\r\n| createdOn | Budget->CreatedOn | string | date-time |\r\n| modifiedByUserId | Budget->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Budget->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Budget->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Budget->ModifiedOn | string | date-time |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | Budget->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | Budget->PermissionTree_Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| siteCode | Budget->Site_Code | string |  |\r\n| siteDescription | Budget->Site_Description | string |  |\r\n| id | Budget->Id | integer | int64 |\r\n| baseCurrencyId | Budget->BaseCurrency_Id | integer | int64 |\r\n| baseCurrencyCode | Budget->BaseCurrency_Code | string |  |\r\n| baseCurrencyDescription | Budget->BaseCurrency_Description | string |  |\r\n| budgetActualAmount | Budget->BudgetActualAmount | number | decimal |\r\n| budgetActualAmountInBaseCurrency | Budget->BudgetActualAmountInBaseCurrency | number | decimal |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetAmountInBaseCurrency | Budget->BudgetAmountInBaseCurrency | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| budgetTemplateCode | Budget->BudgetTemplate_Code | string |  |\r\n| budgetTemplateDescription | Budget->BudgetTemplate_Description | string |  |\r\n| budgetVarianceAmount | Budget->BudgetVarianceAmount | number | decimal |\r\n| budgetVarianceAmountInBaseCurrency | Budget->BudgetVarianceAmountInBaseCurrency | number | decimal |\r\n| conversionRate | Budget->ConversionRate | number | decimal |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| description | Budget->Description | string |  |\r\n| expression | Budget->Expression | string |  |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearId | Budget->FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | Budget->Notes | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n",
        "operationId": "BatchGetBudget",
        "parameters": [
          {
            "name": "ids",
            "in": "path",
            "style": "simple",
            "required": true,
            "description": "A comma separated list of Budget id's (eg. 1585760985950002,1585760985950003)",
            "schema": {
              "type": "array",
              "nullable": true,
              "items": {
                "type": "integer",
                "format": "int64"
              }
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Budget collection",
            "content": {
              "application/vnd.onkey.entitycollection+json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchGetBudgetResourceAction"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Batch": {
      "post": {
        "tags": [
          "Budget"
        ],
        "summary": "Create a new collection of Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | Budget->Code | string |  |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n| financialYearPeriodId | Budget->FinancialYearPeriod_Id | integer | int64 |\r\n| expression | Budget->Expression | string |  |\r\n| currencyId | Budget->Currency_Id | integer | int64 |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| budgetTemplateId | Budget->BudgetTemplate_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| financialYearPeriodId | Required | True |  |\r\n| financialYearPeriodId | Nullable | False |  |\r\n| expression | Required | True |  |\r\n| expression | Nullable | False |  |\r\n| currencyId | Required | True |  |\r\n| currencyId | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n| budgetAmount | Min Value | >= 0|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateBudget",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "posts",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitycollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchCreateBudgetResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "description": "Success response - Budget batch was successfully created"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Update a collection of existing Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| version | Budget->Version | integer | int32 |\r\n| expression | Budget->Expression | string |  |\r\n| status | Budget->Status | string (Allowed values: [UnderDevelopment, Open, Closed]) | enum |\r\n| siteId | Budget->Site_Id | integer | int64 |\r\n| description | Budget->Description | string |  |\r\n| code | Budget->Code | string |  |\r\n| sequenceNumber | Budget->SequenceNumber | integer | int32 |\r\n| notes | Budget->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| expression | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchUpdateBudget",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchUpdateBudgetResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Budget batch was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Budget"
        ],
        "summary": "Delete a collection of existing Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| version | Budget->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteBudget",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "deletes",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydeletecollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchDeleteBudgetResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Budget batch was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/BudgetAmount/Batch": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Batch Set Budget Amount",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | SetBudgetAmount->Id | integer | int64 |\r\n| version | SetBudgetAmount->Version | integer | int32 |\r\n| budgetAmount | SetBudgetAmount->BudgetAmount | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchSetBudgetAmount",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchSetBudgetAmountResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Change the PermissionTree for an existing Budget resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeBudgetPermissionTree",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeBudgetPermissionTreeResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/{id}/BudgetAmount": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Set Budget Amount",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | SetBudgetAmount->Version | integer | int32 |\r\n| budgetAmount | SetBudgetAmount->BudgetAmount | number | decimal |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| budgetAmount | Required | True |  |\r\n| budgetAmount | Nullable | False |  |\r\n\r\n",
        "operationId": "SetBudgetAmount",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/SetBudgetAmountResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Budget"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Budget resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| version | Budget->Version | integer | int32 |\r\n| permissionTreeId | Budget->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeBudgetPermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchChangeBudgetPermissionTreeResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/{id}": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a Budget Parameter resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| createdByUserId | BudgetParameter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | BudgetParameter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | BudgetParameter->CreatedByUser_FullName | string |  |\r\n| createdOn | BudgetParameter->CreatedOn | string | date-time |\r\n| modifiedByUserId | BudgetParameter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | BudgetParameter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | BudgetParameter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | BudgetParameter->ModifiedOn | string | date-time |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | BudgetParameter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | BudgetParameter->PermissionTree_Description | string |  |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| budgetBudgetAmount | BudgetParameter->Budget_BudgetAmount | number | decimal |\r\n| budgetCurrencyId | BudgetParameter->Budget_Currency_Id | integer | int64 |\r\n| budgetCurrencyCode | BudgetParameter->Budget_Currency_Code | string |  |\r\n| budgetCurrencyDescription | BudgetParameter->Budget_Currency_Description | string |  |\r\n| budgetFinancialYearPeriodId | BudgetParameter->Budget_FinancialYearPeriod_Id | integer | int64 |\r\n| budgetFinancialYearPeriodCode | BudgetParameter->Budget_FinancialYearPeriod_Code | string |  |\r\n| budgetFinancialYearPeriodDescription | BudgetParameter->Budget_FinancialYearPeriod_Description | string |  |\r\n| budgetFinancialYearPeriodFinancialYearId | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| budgetFinancialYearPeriodFinancialYearCode | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| budgetFinancialYearPeriodFinancialYearDescription | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | BudgetParameter->Notes | string |  |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| value | BudgetParameter->Value | object | composite |\r\n",
        "operationId": "GetBudgetParameter",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Budget Parameter",
            "content": {
              "application/vnd.onkey.entity+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetBudgetParameterResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Update an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| value | BudgetParameter->Value | object | composite |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| value | Nullable | False |  |\r\n\r\n",
        "operationId": "UpdateBudgetParameter",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateBudgetParameterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Budget Parameter was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Delete an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteBudgetParameter",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "input",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydelete+json": {
              "schema": {
                "$ref": "#/components/schemas/DeleteBudgetParameterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Budget Parameter was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a collection of Budget Parameter resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| value | BudgetParameter->Value | object | composite |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| budgetFinancialYearPeriodCode | BudgetParameter->Budget_FinancialYearPeriod_Code | string |  |\r\n| budgetFinancialYearPeriodDescription | BudgetParameter->Budget_FinancialYearPeriod_Description | string |  |\r\n| budgetFinancialYearPeriodFinancialYearCode | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| budgetFinancialYearPeriodFinancialYearDescription | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Description | string |  |\r\n",
        "operationId": "GetBudgetParameterCollection",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Budget Parameter collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetBudgetParameterCollectionResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "post": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Create a new Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| value | BudgetParameter->Value | object | composite |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| parameterName | Required | True |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| value | Required | True |  |\r\n| value | Nullable | False |  |\r\n| budgetId | Required | True |  |\r\n| budgetId | Nullable | False |  |\r\n\r\n",
        "operationId": "CreateBudgetParameter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "post",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entity+json": {
              "schema": {
                "$ref": "#/components/schemas/CreateBudgetParameterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "$ref": "#/components/responses/created",
            "description": ""
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budgets/{budgetId}/Parameters": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a collection of Budget Parameter resources for the Budget.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| value | BudgetParameter->Value | object | composite |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n",
        "operationId": "GetBudgetParameterForBudgetCollection",
        "parameters": [
          {
            "name": "budgetId",
            "in": "path",
            "required": true,
            "description": "Budget Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Budget Parameter collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetBudgetParameterForBudgetCollectionResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Lookups/LookupBudgetParameterChangePermissionTree": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Lookup the permission set for changing the Budget Parameter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetParameterChangePermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetParameterChangePermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Lookups/LookupBudgetParameterInsertPermissionTree": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Lookup the permission set for creating the Budget Parameter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupBudgetParameterInsertPermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable  collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetParameterInsertPermissionTreeLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Lookups/LookupBudgetParameterBudget": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Lookup the Budget for the Budget Parameter.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Budget->Id | integer | int64 |\r\n| currencyCode | Budget->Currency_Code | string |  |\r\n| currencyDescription | Budget->Currency_Description | string |  |\r\n| budgetAmount | Budget->BudgetAmount | number | decimal |\r\n| financialYearPeriodCode | Budget->FinancialYearPeriod_Code | string |  |\r\n| financialYearPeriodDescription | Budget->FinancialYearPeriod_Description | string |  |\r\n| financialYearPeriodFinancialYearCode | Budget->FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| financialYearPeriodFinancialYearDescription | Budget->FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| expression | Budget->Expression | string |  |\r\n",
        "operationId": "LookupBudgetParameterBudget",
        "parameters": [
          {
            "$ref": "#/components/parameters/Select"
          },
          {
            "$ref": "#/components/parameters/Filter"
          },
          {
            "$ref": "#/components/parameters/Param"
          },
          {
            "$ref": "#/components/parameters/Top"
          },
          {
            "$ref": "#/components/parameters/Skip"
          },
          {
            "$ref": "#/components/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains pageable Budget collection",
            "content": {
              "application/vnd.onkey.entitycollectionpage+json": {
                "schema": {
                  "$ref": "#/components/schemas/BudgetParametersChangeDataTriggerLookupResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch/{ids}": {
      "get": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Get a collection of Budget Parameter resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n| createdByUserId | BudgetParameter->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | BudgetParameter->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | BudgetParameter->CreatedByUser_FullName | string |  |\r\n| createdOn | BudgetParameter->CreatedOn | string | date-time |\r\n| modifiedByUserId | BudgetParameter->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | BudgetParameter->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | BudgetParameter->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | BudgetParameter->ModifiedOn | string | date-time |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | BudgetParameter->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | BudgetParameter->PermissionTree_Description | string |  |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| budgetBudgetAmount | BudgetParameter->Budget_BudgetAmount | number | decimal |\r\n| budgetCurrencyId | BudgetParameter->Budget_Currency_Id | integer | int64 |\r\n| budgetCurrencyCode | BudgetParameter->Budget_Currency_Code | string |  |\r\n| budgetCurrencyDescription | BudgetParameter->Budget_Currency_Description | string |  |\r\n| budgetFinancialYearPeriodId | BudgetParameter->Budget_FinancialYearPeriod_Id | integer | int64 |\r\n| budgetFinancialYearPeriodCode | BudgetParameter->Budget_FinancialYearPeriod_Code | string |  |\r\n| budgetFinancialYearPeriodDescription | BudgetParameter->Budget_FinancialYearPeriod_Description | string |  |\r\n| budgetFinancialYearPeriodFinancialYearId | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Id | integer | int64 |\r\n| budgetFinancialYearPeriodFinancialYearCode | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Code | string |  |\r\n| budgetFinancialYearPeriodFinancialYearDescription | BudgetParameter->Budget_FinancialYearPeriod_FinancialYear_Description | string |  |\r\n| notes | BudgetParameter->Notes | string |  |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| value | BudgetParameter->Value | object | composite |\r\n",
        "operationId": "BatchGetBudgetParameter",
        "parameters": [
          {
            "name": "ids",
            "in": "path",
            "style": "simple",
            "required": true,
            "description": "A comma separated list of Budget Parameter id's (eg. 1585760985950002,1585760985950003)",
            "schema": {
              "type": "array",
              "nullable": true,
              "items": {
                "type": "integer",
                "format": "int64"
              }
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Budget Parameter collection",
            "content": {
              "application/vnd.onkey.entitycollection+json": {
                "schema": {
                  "$ref": "#/components/schemas/BatchGetBudgetParameterResourceAction"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch": {
      "post": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Create a new collection of Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n| value | BudgetParameter->Value | object | composite |\r\n| budgetId | BudgetParameter->Budget_Id | integer | int64 |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| parameterName | Required | True |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| permissionTreeId | System Generated | true | If no value specified |\r\n| permissionTreeId | Nullable | False |  |\r\n| value | Required | True |  |\r\n| value | Nullable | False |  |\r\n| budgetId | Required | True |  |\r\n| budgetId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchCreateBudgetParameter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "posts",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitycollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchCreateBudgetParameterRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "201": {
            "description": "Success response - Budget Parameter batch was successfully created"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Update a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| parameterName | BudgetParameter->ParameterName | string |  |\r\n| value | BudgetParameter->Value | object | composite |\r\n| sequenceNumber | BudgetParameter->SequenceNumber | integer | int32 |\r\n| notes | BudgetParameter->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| parameterName | Nullable | False |  |\r\n| parameterName | Min Length | >= 1 chars|  |\r\n| parameterName | Max Length | <= 50 chars|  |\r\n| value | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchUpdateBudgetParameter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchUpdateBudgetParameterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Budget Parameter batch was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Delete a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteBudgetParameter",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "deletes",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitydeletecollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchDeleteBudgetParameterResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - Budget Parameter batch was successfully deleted"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/{id}/Active": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the IsActive status for an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeBudgetParameterIsActive",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeBudgetParameterIsActiveResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the PermissionTree for an existing Budget Parameter resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeBudgetParameterPermissionTree",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Parameter Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/ChangeBudgetParameterPermissionTreeResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch/Active": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the IsActive status for a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| isActive | BudgetParameter->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeBudgetParameterIsActive",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchChangeBudgetParameterIsActiveResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/Budget/Parameters/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Budget Parameter"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Budget Parameter resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | BudgetParameter->Id | integer | int64 |\r\n| version | BudgetParameter->Version | integer | int32 |\r\n| permissionTreeId | BudgetParameter->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeBudgetParameterPermissionTree",
        "parameters": [
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          },
          {
            "$ref": "#/components/parameters/ExecutionMode"
          }
        ],
        "requestBody": {
          "x-name": "patches",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatchcollection+json": {
              "schema": {
                "$ref": "#/components/schemas/BatchChangeBudgetParameterPermissionTreeResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "204": {
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      }
    },
    "/Modules/FIN/BudgetTemplates/{id}": {
      "get": {
        "tags": [
          "Budget Template"
        ],
        "summary": "Get a Budget Template resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | BudgetTemplate->Code | string |  |\r\n| isActive | BudgetTemplate->IsActive | boolean |  |\r\n| createdByUserId | BudgetTemplate->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | BudgetTemplate->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | BudgetTemplate->CreatedByUser_FullName | string |  |\r\n| createdOn | BudgetTemplate->CreatedOn | string | date-time |\r\n| modifiedByUserId | BudgetTemplate->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | BudgetTemplate->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | BudgetTemplate->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | BudgetTemplate->ModifiedOn | string | date-time |\r\n| version | BudgetTemplate->Version | integer | int32 |\r\n| permissionTreeId | BudgetTemplate->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | BudgetTemplate->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | BudgetTemplate->PermissionTree_Description | string |  |\r\n| id | BudgetTemplate->Id | integer | int64 |\r\n| budgetAmount | BudgetTemplate->BudgetAmount | number | decimal |\r\n| description | BudgetTemplate->Description | string |  |\r\n| expression | BudgetTemplate->Expression | string |  |\r\n| isInitialised | BudgetTemplate->IsInitialised | boolean |  |\r\n| isInitialisedReason | BudgetTemplate->IsInitialisedReason | string (Allowed values: [ExpressionOrParametersAreInvalid]) | enum |\r\n| notes | BudgetTemplate->Notes | string |  |\r\n| sequenceNumber | BudgetTemplate->SequenceNumber | integer | int32 |\r\n",
        "operationId": "GetBudgetTemplate",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Template Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "description": "Success response - body contains Budget Template",
            "content": {
              "application/vnd.onkey.entity+json": {
                "schema": {
                  "$ref": "#/components/schemas/GetBudgetTemplateResourceActionResponse"
                }
              }
            }
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "patch": {
        "tags": [
          "Budget Template"
        ],
        "summary": "Update an existing Budget Template resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | BudgetTemplate->Version | integer | int32 |\r\n| code | BudgetTemplate->Code | string |  |\r\n| expression | BudgetTemplate->Expression | string |  |\r\n| budgetAmount | BudgetTemplate->BudgetAmount | number | decimal |\r\n| description | BudgetTemplate->Description | string |  |\r\n| sequenceNumber | BudgetTemplate->SequenceNumber | integer | int32 |\r\n| notes | BudgetTemplate->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| expression | Nullable | False |  |\r\n| budgetAmount | Nullable | False |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "UpdateBudgetTemplate",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Budget Template Id",
            "schema": {
              "type": "integer",
              "format": "int64"
            },
            "x-position": 1
          },
          {
            "$ref": "#/components/parameters/Async"
          },
          {
            "$ref": "#/components/parameters/AsyncDescription"
          },
          {
            "$ref": "#/components/parameters/Schedule"
          }
        ],
        "requestBody": {
          "x-name": "patch",
          "description": "Request Body content",
          "content": {
            "application/vnd.onkey.entitypatch+json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateBudgetTemplateResourceActionRequest"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "204": {
            "description": "Success response - Budget Template was successfully updated"
          },
          "202": {
            "$ref": "#/components/responses/accepted",
            "description": ""
          },
          "default": {
            "$ref": "#/components/responses/default",
            "description": ""
          }
        }
      },
      "delete": {
        "tags": [
          "Budget Template"
        ],
        "summary": "Delete an existing Budget Template resource.",
[...]
